# GraphOrchestrator

[![CI](https://github.com/AbhinavS99/GraphOrchestrator/actions/workflows/ci.yml/badge.svg)](https://github.com/AbhinavS99/GraphOrchestrator/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/AbhinavS99/GraphOrchestrator/graph/badge.svg?token=U69VNUUQ6I)](https://codecov.io/gh/AbhinavS99/GraphOrchestrator)
[![PyPI version](https://badge.fury.io/py/graph-orchestrator.svg)](https://badge.fury.io/py/graph-orchestrator)

**GraphOrchestrator** is a lightweight Python library for building and executing dynamic workflows as directed graphs. It allows you to define processing logic as **nodes**, control flow via **concrete and conditional edges**, and orchestrate execution with support for:

- ✅ **Decorator-driven design** for node actions, routing logic, and aggregators  
- 🔁 **Retry policies** and fault-tolerant execution  
- 🧠 **Conditional branching** using routing functions  
- 🤝 **Parallel and aggregated state processing**  
- 🎨 **Graph visualization** with Matplotlib  
- 🧪 **Built-in testability** with full unit test coverage  

Whether you're designing decision engines, agent workflows, or data pipelines—GraphOrchestrator offers an intuitive and extensible framework for graph-based execution.